Require Import MyTactics.
Require Import LabelAlgebra.
Require Import FinSetLattice.
Require Import Principal.
Require Import CFinSetLattice.
Require Import Endorsement.
Require Import CTaint.

Set Implicit Arguments.

Instance CEndorsement : LabelAlgebra (CFinSet Prin.t) (CFinSet Prin.t) :=
{ Ldef := CFinSet_intro (@Ldef _ _ Endorsement)
; labLeq := flip CFinSet_included
; authLeq := CFinSet_included
; flowsTo a := flip (ctaint_flowsTo a)

; flowsToPreOrder a :=
    flip_PreOrder_instance _ _ (CTaint_flowsTo_PreOrder a)
; flowsToJoinPreLattice a :=
    flip_JoinPrelattice _ _ _ (CTaint_MeetPrelattice a)
; flowsToMeetPreLattice a :=
    flip_MeetPrelattice _ _ _ (CTaint_JoinPrelattice a)
}.
Proof.
* split; unfold flip; intros s1 s2 H;
  apply (@flowsToBottom _ _ CTaint); assumption.
* auto.
* auto.
* intros a1 a2 H12 s s'. unfold flip in *.
  apply (@flowsToIncluded _ _ CTaint). assumption.
Defined.
