Require Import MyTactics.
Require Import LabelAlgebra.
Require Import LabelSemantics.
Require Import BooleanSemantics.
Require Import EvaluationSemantics.
Require Export CTaint.
Require Export UReader.
Require Import EmbedUTUR.
Require Import EmbedCTUT.
Require Import EmbedTableCheck.

(** * Intermediate lemmas. *)
Lemma injects_CT_UR: CTaint ↪ UReader.
Proof.
transitivity_embeds UTaint; solve_embed.
Qed.
Hint Resolve injects_CT_UR.

Lemma not_boolean_embeds_UR_CT: ~(UReader ==>[boolean_sem] CTaint).
Proof.
apply embeds_in_trans_not1
with (sem := boolean_sem)
     (LA1 := UTaint)
     (LA2 := UReader)
     (LA3 := CTaint);
solve_embed.
Qed.
Hint Resolve not_boolean_embeds_UR_CT.

(** * Summary *)
Open Scope table.

Theorem injects_CT_UR_summary :
  property_square_table injects_in
     [| CTaint; UReader |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem boolean_embed_CT_UR_summary :
  embed_table boolean_sem
     [| CTaint; UReader |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem eval_embed_CT_UR_summary :
  embed_table eval_sem
     [| CTaint; UReader |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Close Scope table.
