Require Import String.
Require Import LabelAlgebra.
Require Import LabelSemantics.
Require Import BooleanSemantics.
Require Import EvaluationSemantics.
Require Import EmbedTCT.
Require Import EmbedCTUT.
Require Import EmbedTUT.
Require Import EmbedECE.
Require Import EmbedCEUE.
Require Import EmbedEUE.
Require Import EmbedCRUR.
Require Import EmbedCDUD.
Require Import EmbedUTUD.
Require Import EmbedCTCD.
Require Import EmbedUTCD.
Require Import EmbedCTUD.
Require Import EmbedTCD.
Require Import EmbedTUD.
Require Import EmbedCRCE.
Require Import EmbedURUE.
Require Import EmbedCRUE.
Require Import EmbedURCE.
Require Import EmbedCRE.
Require Import EmbedURE.
Require Import EmbedUTUR.
Require Import EmbedCTUR.
Require Import EmbedTUR.
Require Import EmbedUTCR.
Require Import EmbedCTCR.
Require Import EmbedTCR.
Require Import EmbedUDUE.
Require Import EmbedCDUE.
Require Import EmbedCDE.
Require Import EmbedCDCE.
Require Import EmbedUDCE.
Require Import EmbedUDE.
Require Import EmbedURUD.
Require Import EmbedURCD.
Require Import EmbedCRUD.
Require Import EmbedCRCD.
Require Import EmbedUTUE.
Require Import EmbedUTCE.
Require Import EmbedCTUE.
Require Import EmbedCTCE.
Require Import EmbedCTE.
Require Import EmbedTCE.
Require Import EmbedTUE.
Require Import EmbedUTE.
Require Import EmbedTE.
Require Import EmbedTableCheck.

(** * Summary of embeddability results between set-based examples. *)
Open Scope table. Open Scope string.

Definition setLAs : LAs :=
  [| Taint; CTaint; UTaint
   ; Endorsement; CEndorsement; UEndorsement
   ; CReader; UReader
   ; CDistrust; UDistrust
  |].

Definition setLAnames :=
  [ "T"; "CT"; "UT"
  ; "E"; "CE"; "UE"
  ; "CR"; "UR"
  ; "CD"; "UD"
  ].

Definition boolean_table :=
  [ [ ✓; ✓; ✓; ×; ×; ✓; ×; ✓; ✓; ✓ ]
  ; [ ×; ✓; ✓; ×; ×; ✓; ×; ✓; ✓; ✓ ]
  ; [ ×; ×; ✓; ×; ×; ✓; ×; ✓; ×; ✓ ]
  ; [ ×; ×; ✓; ✓; ✓; ✓; ✓; ✓; ×; ✓ ]
  ; [ ×; ×; ✓; ×; ✓; ✓; ✓; ✓; ×; ✓ ]
  ; [ ×; ×; ✓; ×; ×; ✓; ×; ✓; ×; ✓ ]
  ; [ ×; ×; ✓; ×; ✓; ✓; ✓; ✓; ×; ✓ ]
  ; [ ×; ×; ✓; ×; ×; ✓; ×; ✓; ×; ✓ ]
  ; [ ×; ✓; ✓; ×; ×; ✓; ×; ✓; ✓; ✓ ]
  ; [ ×; ×; ✓; ×; ×; ✓; ×; ✓; ×; ✓ ]
  ].

Theorem boolean_embed_set_examples_summary :
  embed_table
    boolean_sem
    setLAs
    boolean_table.
Proof.
solve_embed_table.
Qed.

(** Exporting the table of boolean embeddings to LaTeX. *)
Definition print_boolean_table :=
  ExportTo.TeX.print_simple
    setLAnames setLAnames
    boolean_table.
Extraction "EmbedSetExamplesSummary_boolean.ml" print_boolean_table.

Definition eval_table :=
  [ [ ✓; ✓; ✓; ×; ×; ×; ×; ✓; ×; × ]
  ; [ ×; ✓; ✓; ×; ×; ×; ×; ✓; ×; × ]
  ; [ ×; ×; ✓; ×; ×; ×; ×; ✓; ×; × ]
  ; [ ×; ×; ×; ✓; ✓; ✓; ×; ×; ×; ✓ ]
  ; [ ×; ×; ×; ×; ✓; ✓; ×; ×; ×; ✓ ]
  ; [ ×; ×; ×; ×; ×; ✓; ×; ×; ×; ✓ ]
  ; [ ×; ×; ✓; ×; ×; ×; ✓; ✓; ×; × ]
  ; [ ×; ×; ✓; ×; ×; ×; ×; ✓; ×; × ]
  ; [ ×; ×; ×; ×; ×; ✓; ×; ×; ✓; ✓ ]
  ; [ ×; ×; ×; ×; ×; ✓; ×; ×; ×; ✓ ]
  ].

Theorem eval_embed_set_examples_summary :
  embed_table
    eval_sem
    setLAs
    eval_table.
Proof.
solve_embed_table.
Qed.

(** Exporting the table of boolean embeddings to LaTeX. *)
Definition print_eval_table :=
  ExportTo.TeX.print_simple
    setLAnames setLAnames
    eval_table.
Extraction "EmbedSetExamplesSummary_eval.ml" print_eval_table.

Theorem injects_set_examples_summary :
  property_square_table injects_in
    setLAs
    eval_table.
Proof.
solve_embed_table.
Qed.

(** Exporting the table of boolean embeddings to LaTeX. *)
Definition print_inject_table :=
  ExportTo.TeX.print_simple
    setLAnames setLAnames
    eval_table.
Extraction "EmbedSetExamplesSummary_inject.ml" print_inject_table.

Close Scope string.
Close Scope table.
