val fst : ('a1*'a2) -> 'a1

val snd : ('a1*'a2) -> 'a2

type string =
| EmptyString
| String of char * string

val append : string -> string -> string

val combine : ('a1 -> 'a2 -> 'a3) -> 'a1 list -> 'a2 list -> 'a3 list

type answer =
| Yes
| No
| Unknown

module ExportTo : 
 sig 
  val print_string : string -> unit
  
  val list_to_string :
    string -> string -> string -> ('a1 -> string) -> 'a1 list -> string
  
  val table_to_string :
    string -> string -> string -> ('a1 -> string) -> 'a1 list -> string ->
    string -> string -> ('a2 -> string) -> 'a2 list -> string -> string ->
    string -> ('a3 -> string) -> 'a3 list list -> string
  
  module HTML : 
   sig 
    val export_answer : answer -> string
    
    val export :
      ('a1 -> string) -> ('a2 -> string) -> 'a1 list -> 'a2 list -> answer
      list list -> string
    
    val export_simple :
      string list -> string list -> answer list list -> string
    
    val print :
      ('a1 -> string) -> ('a2 -> string) -> 'a1 list -> 'a2 list -> answer
      list list -> unit
    
    val print_simple : string list -> string list -> answer list list -> unit
   end
  
  module TeX : 
   sig 
    val newline : string
    
    val export_answer : answer -> string
    
    val export :
      ('a1 -> string) -> ('a2 -> string) -> 'a1 list -> 'a2 list -> answer
      list list -> string
    
    val export_simple :
      string list -> string list -> answer list list -> string
    
    val print :
      ('a1 -> string) -> ('a2 -> string) -> 'a1 list -> 'a2 list -> answer
      list list -> unit
    
    val print_simple : string list -> string list -> answer list list -> unit
   end
 end

val setLAnames : string list

val eval_table : answer list list

val print_eval_table : unit

