Require Import MyTactics.
Require Import LabelAlgebra.
Require Import LabelSemantics.
Require Import BooleanSemantics.
Require Import EvaluationSemantics.
Require Export Taint.
Require Export UReader.
Require Import EmbedUTUR.
Require Import EmbedTUT.
Require Import EmbedTableCheck.

(** * Intermediate lemmas. *)
Lemma injects_T_UR: Taint ↪ UReader.
Proof.
transitivity_embeds UTaint; solve_embed.
Qed.
Hint Resolve injects_T_UR.

Lemma not_boolean_embeds_UR_T: ~(UReader ==>[boolean_sem] Taint).
Proof.
apply embeds_in_trans_not1
with (sem := boolean_sem)
     (LA1 := UTaint)
     (LA2 := UReader)
     (LA3 := Taint);
solve_embed.
Qed.
Hint Resolve not_boolean_embeds_UR_T.

(** * Summary *)
Open Scope table.

Theorem injects_T_UR_summary :
  property_square_table injects_in
     [| Taint; UReader |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem boolean_embed_T_UR_summary :
  embed_table boolean_sem
     [| Taint; UReader |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem eval_embed_T_UR_summary :
  embed_table eval_sem
     [| Taint; UReader |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Close Scope table.
