Require Import LabelAlgebra.
Require Import LabelSemantics.
Require Import BooleanSemantics.
Require Import EvaluationSemantics.
Require Import EmbedTrivialTwo.
Require Import EmbedTrivialThree.
Require Import EmbedTrivialFour.
Require Import EmbedTrivialFourD.
Require Import EmbedTwoThree.
Require Import EmbedTwoFour.
Require Import EmbedTwoFourD.
Require Import EmbedThreeFour.
Require Import EmbedThreeFourD.
Require Import EmbedFourFourD.
Require Import EmbedTableCheck.

(** * Summary of embeddability results between trivial examples. *)
Open Scope table.

Definition simpleLAs : LAs :=
  [| Trivial; Two; Three; Four; FourD |].

Definition table :=
  [ [ ✓; ✓; ✓; ✓; ✓ ]
  ; [ ×; ✓; ✓; ✓; ✓ ]
  ; [ ×; ×; ✓; ✓; ✓ ]
  ; [ ×; ×; ×; ✓; × ]
  ; [ ×; ×; ×; ×; ✓ ]
  ].

Theorem injects_trivial_summary :
  property_square_table injects_in
    simpleLAs
    table.
Proof.
solve_embed_table.
Qed.

Theorem boolean_embed_trivial_summary :
  embed_table
    boolean_sem
    simpleLAs
    table.
Proof.
unfold simpleLAs. unfold table. solve_embed_table.
Qed.

Theorem eval_embed_trivial_summary :
  embed_table
    eval_sem
    simpleLAs
    table.
Proof.
unfold simpleLAs. unfold table. solve_embed_table.
Qed.

Close Scope table.
