Require Import MyTactics.
Require Import LabelAlgebra.
Require Import LabelSemantics.
Require Import BooleanSemantics.
Require Import EvaluationSemantics.
Require Export UTaint.
Require Export CReader.
Require Import EmbedCRUR.
Require Import EmbedUTUR.
Require Import EmbedTableCheck.

(** * Intermediate lemmas. *)
Lemma injects_CR_UT: CReader ↪ UTaint.
Proof.
transitivity_embeds UReader; solve_embed.
Qed.
Hint Resolve injects_CR_UT.

Lemma not_boolean_embeds_UT_CR: ~(UTaint ==>[boolean_sem] CReader).
Proof.
apply embeds_in_trans_not1
with (sem := boolean_sem)
     (LA1 := UReader)
     (LA2 := UTaint)
     (LA3 := CReader);
solve_embed.
Qed.
Hint Resolve not_boolean_embeds_UT_CR.

(** * Summary *)
Open Scope table.

Theorem injects_UT_CR_summary :
  property_square_table injects_in
     [| UTaint; CReader |]
     [ [ ✓; × ]
     ; [ ✓; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem boolean_embed_UT_CR_summary :
  embed_table boolean_sem
     [| UTaint; CReader |]
     [ [ ✓; × ]
     ; [ ✓; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem eval_embed_UT_CR_summary :
  embed_table eval_sem
     [| UTaint; CReader |]
     [ [ ✓; × ]
     ; [ ✓; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Close Scope table.
