Require Import MyTactics.
Require Import LabelAlgebra.
Require Import FinSetLattice.
Require Import Principal.
Require Import Taint.

Set Implicit Arguments.

Instance Endorsement : LabelAlgebra (FinSet Prin.t) (FinSet Prin.t) :=
{ Ldef := FinSet_empty _
; labLeq := flip FinSet_included
; authLeq := FinSet_included
; flowsTo a := flip (taint_flowsTo a)

; flowsToPreOrder a :=
    flip_PreOrder_instance _ _ (Taint_flowsTo_PreOrder a)
; flowsToJoinPreLattice a :=
    flip_JoinPrelattice _ _ _ (Taint_MeetPrelattice a)
; flowsToMeetPreLattice a :=
    flip_MeetPrelattice _ _ _ (Taint_JoinPrelattice a)
}.
Proof.
* split; unfold flip; intros s1 s2 H;
  apply (@flowsToBottom _ _ Taint); assumption.
* auto.
* auto.
* intros a1 a2 H12 s s'. unfold flip in *.
  apply (@flowsToIncluded _ _ Taint). assumption.
Defined.
