Require Import MyTactics.
Require Import LabelAlgebra.
Require Import Principal.
Require Import Ensembles.
Require Import Endorsement.
Require Import UTaint.

Set Implicit Arguments.

Instance UEndorsement : LabelAlgebra (Ensemble Prin.t) (Ensemble Prin.t) :=
{ Ldef := proj1_sig (@Ldef _ _ Endorsement)
; labLeq := flip (Included Prin.t)
; authLeq := Included Prin.t
; flowsTo a := flip (taint_flowsTo a)

; flowsToPreOrder a :=
    flip_PreOrder_instance _ _ (Taint_flowsTo_PreOrder a)
; flowsToJoinPreLattice a :=
    flip_JoinPrelattice _ _ _ (Taint_MeetPrelattice a)
; flowsToMeetPreLattice a :=
    flip_MeetPrelattice _ _ _ (Taint_JoinPrelattice a)
}.
Proof.
* split; unfold flip; intros s1 s2 H;
  apply (@flowsToBottom _ _ UTaint); assumption.
* auto.
* auto.
* intros a1 a2 H12 s s'. unfold flip in *.
  apply (@flowsToIncluded _ _ UTaint). assumption.
Defined.
