Require Import MyTactics.
Require Import LabelAlgebra.
Require Import LabelSemantics.
Require Import BooleanSemantics.
Require Import EvaluationSemantics.
Require Export Four.
Require Export FourD.
Require Import EmbedTableCheck.

(** * Intermediate lemmas. *)
Lemma not_boolean_embeds_four_fourD: ~ (Four ==>[boolean_sem] FourD).
Proof.
rewrite boolean_embeds_iff.
intros [m [Hm1 Hm2]].
case_eq (Lmap m Bottom4); intro Heq1;
case_eq (Lmap m LMiddle4); intro Heq2; exploit_eq;
case_eq (Lmap m UMiddle4); intro Heq3; exploit_eq;
case_eq (Lmap m Top4); intro Heq4; exploit_eq.
Qed.
Hint Resolve not_boolean_embeds_four_fourD.

Lemma not_boolean_embeds_fourD_four: ~(FourD ==>[boolean_sem] Four).
Proof.
rewrite boolean_embeds_iff.
intros [m [Hm1 Hm2]].
case_eq (Lmap m Bottom4D); intro Heq1;
case_eq (Lmap m LMiddle4D); intro Heq2; exploit_eq;
case_eq (Lmap m RMiddle4D); intro Heq3; exploit_eq;
case_eq (Lmap m Top4D); intro Heq4; exploit_eq.
Qed.
Hint Resolve not_boolean_embeds_fourD_four.

(** * Summary *)
Open Scope table.

Theorem injects_four_fourD_summary :
  property_square_table injects_in
     [| Four; FourD |]
     [ [ ✓; × ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem boolean_embed_four_fourD_summary :
  embed_table boolean_sem
     [| Four; FourD |]
     [ [ ✓; × ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem eval_embed_four_fourD_summary :
  embed_table eval_sem
     [| Four; FourD |]
     [ [ ✓; × ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Close Scope table.
