Require Import LabelAlgebra.
Require Import LabelSemantics.
Require Import BooleanSemantics.
Require Import EvaluationSemantics.
Require Export Trivial.
Require Export Four.
Require Import EmbedTrivialTwo.
Require Import EmbedTwoFour.
Require Import EmbedTableCheck.

(** * Intermediate lemmas. *)
Lemma injects_trivial_four: Trivial ↪ Four.
Proof.
transitivity_embeds Two; solve_embed.
Qed.
Hint Resolve injects_trivial_four.

Lemma not_boolean_embeds_four_trivial: ~(Four ==>[boolean_sem] Trivial).
Proof.
rewrite boolean_embeds_iff.
intros [m [Hm1 Hm2]].
case_eq (Lmap m Bottom4); intro;
case_eq (Lmap m Top4); intro;
exploit_eq.
Qed.
Hint Resolve not_boolean_embeds_four_trivial.

(** * Summary *)
Open Scope table.

Theorem injects_trivial_four_summary :
  property_square_table injects_in
     [| Trivial; Four |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem boolean_embed_trivial_four_summary :
  embed_table boolean_sem
     [| Trivial; Four |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem eval_embed_trivial_four_summary :
  embed_table eval_sem
     [| Trivial; Four |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Close Scope table.
