Require Import LabelAlgebra.
Require Import LabelSemantics.
Require Import BooleanSemantics.
Require Import EvaluationSemantics.
Require Export Trivial.
Require Export FourD.
Require Import EmbedTrivialTwo.
Require Import EmbedTwoFourD.
Require Import EmbedTableCheck.

(** * Intermediate lemmas. *)
Lemma injects_trivial_fourD: Trivial ↪ FourD.
Proof.
transitivity_embeds Two; solve_embed.
Qed.
Hint Resolve injects_trivial_fourD.

Lemma not_boolean_embeds_fourD_trivial: ~(FourD ==>[boolean_sem] Trivial).
Proof.
rewrite boolean_embeds_iff.
intros [m [Hm1 Hm2]].
case_eq (Lmap m Bottom4D); intro;
case_eq (Lmap m Top4D); intro;
exploit_eq.
Qed.
Hint Resolve not_boolean_embeds_fourD_trivial.

(** * Summary *)
Open Scope table.

Theorem injects_trivial_fourD_summary :
  property_square_table injects_in
     [| Trivial; FourD |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem boolean_embed_trivial_fourD_summary :
  embed_table boolean_sem
     [| Trivial; FourD |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem eval_embed_trivial_fourD_summary :
  embed_table eval_sem
     [| Trivial; FourD |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Close Scope table.
