Require Import LabelAlgebra.
Require Import LabelSemantics.
Require Import BooleanSemantics.
Require Import EvaluationSemantics.
Require Export Trivial.
Require Export Three.
Require Import EmbedTrivialTwo.
Require Import EmbedTwoThree.
Require Import EmbedTableCheck.

(** * Intermediate lemmas. *)
Lemma injects_trivial_three: Trivial ↪ Three.
Proof.
transitivity_embeds Two; solve_embed.
Qed.
Hint Resolve injects_trivial_three.

Lemma not_boolean_embeds_three_trivial: ~(Three ==>[boolean_sem] Trivial).
Proof.
rewrite boolean_embeds_iff.
intros [m [Hm1 Hm2]].
case_eq (Lmap m Bottom3); intro;
case_eq (Lmap m Top3); intro; exploit_eq.
Qed.
Hint Resolve not_boolean_embeds_three_trivial.

(** * Summary *)
Open Scope table.

Theorem injects_trivial_three_summary :
  property_square_table injects_in
     [| Trivial; Three |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem boolean_embed_trivial_three_summary :
  embed_table boolean_sem
     [| Trivial; Three |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem eval_embed_trivial_three_summary :
  embed_table eval_sem
     [| Trivial; Three |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Close Scope table.
