Require Import MyTactics.
Require Import LabelAlgebra.
Require Import LabelSemantics.
Require Import BooleanSemantics.
Require Import EvaluationSemantics.
Require Export Trivial.
Require Export Two.
Require Import EmbedTableCheck.

(** * Intermediate lemmas. *)
Lemma injects_trivial_two: Trivial ↪ Two.
Proof.
exists {| Lmap l := bottom; Amap a := bottom |}.
rewrite LAinjection_iff. unfold LAinjection_prop.
compute; tauto.
Qed.
Hint Resolve injects_trivial_two.

Lemma not_boolean_embeds_two_trivial: ~(Two ==>[boolean_sem] Trivial).
Proof.
rewrite boolean_embeds_iff.
intros [m [Hm1 Hm2]].
case_eq (Lmap m Bottom2); intro;
case_eq (Lmap m Top2); intro; exploit_eq.
Qed.
Hint Resolve not_boolean_embeds_two_trivial.

(** * Summary *)
Open Scope table.

Theorem injects_trivial_two_summary :
  property_square_table injects_in
     [| Trivial; Two |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem boolean_embed_trivial_two_summary :
  embed_table boolean_sem
     [| Trivial; Two |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem eval_embed_trivial_two_summary :
  embed_table eval_sem
     [| Trivial; Two |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Close Scope table.
