Require Import MyTactics.
Require Import LabelAlgebra.
Require Import LabelSemantics.
Require Import BooleanSemantics.
Require Import EvaluationSemantics.
Require Export Two.
Require Export Four.
Require Import EmbedTwoThree.
Require Import EmbedThreeFour.
Require Import EmbedTableCheck.

(** * Intermediate lemmas. *)
Lemma injects_two_four: Two ↪ Four.
Proof.
transitivity_embeds Three; solve_embed.
Qed.
Hint Resolve injects_two_four.

Lemma not_boolean_embeds_four_two: ~(Four ==>[boolean_sem] Two).
Proof.
rewrite boolean_embeds_iff.
intros [m [Hm1 Hm2]].
case_eq (Lmap m Bottom4); intro Heq1;
case_eq (Lmap m LMiddle4); intro Heq2; exploit_eq;
case_eq (Lmap m UMiddle4); intro Heq3; exploit_eq;
case_eq (Lmap m Top4); intro Heq4; exploit_eq.
Qed.
Hint Resolve not_boolean_embeds_four_two.

(** * Summary *)
Open Scope table.

Theorem injects_two_four_summary :
  property_square_table injects_in
     [| Two; Four |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem boolean_embed_two_four_summary :
  embed_table boolean_sem
     [| Two; Four |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem eval_embed_two_four_summary :
  embed_table eval_sem
     [| Two; Four |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Close Scope table.
