Require Import MyTactics.
Require Import LabelAlgebra.
Require Import LabelSemantics.
Require Import BooleanSemantics.
Require Import EvaluationSemantics.
Require Export Two.
Require Export FourD.
Require Import EmbedTwoThree.
Require Import EmbedThreeFourD.
Require Import EmbedTableCheck.

(** * Intermediate lemmas. *)
Lemma injects_two_fourD: Two ↪ FourD.
Proof.
transitivity_embeds Three; solve_embed.
Qed.
Hint Resolve injects_two_fourD.

Lemma not_boolean_embeds_fourD_two: ~(FourD ==>[boolean_sem] Two).
Proof.
rewrite boolean_embeds_iff.
intros [m [Hm1 Hm2]].
case_eq (Lmap m Bottom4D); intro Heq1;
case_eq (Lmap m LMiddle4D); intro Heq2; exploit_eq;
case_eq (Lmap m Top4D); intro Heq3; exploit_eq.
Qed.
Hint Resolve not_boolean_embeds_fourD_two.

(** * Summary *)
Open Scope table.

Theorem injects_two_fourD_summary :
  property_square_table injects_in
     [| Two; FourD |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem boolean_embed_two_fourD_summary :
  embed_table boolean_sem
     [| Two; FourD |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Theorem eval_embed_two_fourD_summary :
  embed_table eval_sem
     [| Two; FourD |]
     [ [ ✓; ✓ ]
     ; [ ×; ✓ ]
     ].
Proof.
solve_embed_table.
Qed.

Close Scope table.
